package APRSdecu;

#################################################################
##                                                             ##
##  This is a modified version of the aprsdecu.pl which is     ##
##  coverd by the following copyright.                         ##
##  Updated by William McKeehan, KI4HDU                        ##
##                                                             ##
#################################################################
#################################################################
##                                                             ##
## Copyright (C) 2000 Ian Wade, G3NRW.        <g3nrw@arrl.net> ##
##                                                             ##
## <APRSdec> is a trademark owned by Ian Wade, G3NRW.          ##
##                                                             ##
## This program is free software; you can redistribute it and/ ##
## or modify it under the terms of the GNU General Public      ##
## License as published by the Free Software Foundation;       ##
## either version 2 of the License, or (at your option) any    ##
## later version.                                              ##
##                                                             ##
## This program is distributed in the hope that it will be     ##
## useful, but WITHOUT ANY WARRANTY; without even the implied  ##
## warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR     ##
## PURPOSE.  See the GNU General Public License for more       ##
## details.                                                    ##
##                                                             ##
## You should have received a copy of the GNU General Public   ##
## License along with this program (in file LICENSE.TXT); if   ##
## not, please write to the Free Software Foundation, Inc.,    ##
## 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.   ##
##                                                             ##
#################################################################
#################################################################

sub new {
	my $class = shift;
	my $self = {};

	bless $self, $class;
	return $self;
}
#################################################################
########################     ARRAYS    ##########################
#################################################################

@Month  = ("Jan", "Feb", "Mar", "Apr", "May", "Jun",
           "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"); 

@Dti    = (
          "Current Mic-E (Rev0 beta) ", "&A28", # 0x1c
          "Old Mic-E (Rev0 beta)     ", "&A29", # 0x1d
          "****** INVALID 0x1e       ", "",     # 0x1e
          "****** INVALID 0x1f       ", "",     # 0x1f
          "(** Beacon, not APRS)     ", "",
          "Posit w/o time. No APRS   ", "&A33", # ! [5]
          "(** Beacon, not APRS)     ", "",
          "Peet Bros U-II WX Station ", "&A35", # # [7]
          "Raw GPS NMEA Data         ", "&A36", # $ [8]
          "Agrelo DF Jr/Microfinder  ", "&A37", # % [9]
          "(** Beacon, not APRS)     ", "",
          "Old Mic-E Data            ", "&A39", # ' [11]
          "(** Beacon, not APRS)     ", "", 
          "Item                      ", "&A41", # ) [13]
          "Peet Bros U-II WX Station ", "&A42", # * [14]
          "(Shelter data with time)  ", "&A43", # + [15]
          "Invalid data or test data ", "&A44", # , [16]
          "(** Beacon, not APRS)     ", "", 
          "(Space weather)           ", "&A46", # . [18]
          "Posit w/ time. No APRS    ", "&A47", # / [19]
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 50
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 55
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "Message                   ", "&A58", # : [30]
          "Object                    ", "&A59", # ; [31]
          "Station Capabilities      ", "&A60", # < [32]
          "Posit w/o time. With APRS ", "&A61", # = [33]
          "Status                    ", "&A62", # > [34]
          "Query                     ", "&A63", # ? [35]
          "Posit w/ time. With APRS  ", "&A64", # @ [36]
          "(** Beacon, not APRS)     ", "", 
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 70
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 75
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 80
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "Telemetry                 ", "&A84", # T [56]
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 90
          "Maidenhead Grid Square    ", "&A91", # [ [63]
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "Positionless WX Station   ", "&A95", # _ [67]
          "Current Mic-E data        ", "&A96", # ` [68]
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 100
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 105
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 110
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 115
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",     # 120
          "(** Beacon, not APRS)     ", "",
          "(** Beacon, not APRS)     ", "",
          "User-defined packet       ", "&A123",# { [95]
          "(** Beacon, not APRS)     ", "",
          "Third-party traffic       ", "&A125",# } [97]
          "(** Beacon, not APRS)     ", "",
          "Ultimeter WX station      ", "&A127",# !![99]  ersatz
          "Ultimeter WX station      ", "&A128",# $$[100] ersatz
          "Ultimeter WX station      ", "&A129" # $U[101] ersatz
          );
          
$maxDti = @Dti / 2 - 1;

          
@Sym =    (
          "   (No Icon)        (No Icon)     ",
          "BB Police,SheriffOB Emergency     ",   # 1
          "BC **INVALID ICONOC **INVALID ICON",
          "BD Digi (white)  ODzStar (green)  ",
          "BE Phone         OE Bank/ATM      ",
          "BF DX Cluster    OF **INVALID ICON",   # 5
          "BG HF Gateway    OGzDiamond       ",
          "BH Small AircraftOH Crash site    ",
          "BI Cloudy        OI Cloudy        ",
          "BJ **INVALID ICONOJ **INVALID ICON",
          "BK Snowmobile    OK Snow          ",   # 10
          "BL Red Cross     OL Church        ",
          "BM Boy Scouts    OM Girl Scouts   ",
          "BN House QTH VHF ON House HF      ",
          "BO X             OO Unknown posit ",
          "BP Dot           OP **INVALID ICON",   # 15
          "P0 Num Circle 0  A0zCircle        ",
          "P1 Num Circle 1  A1 **INVALID ICON",
          "P2 Num Circle 2  A2 **INVALID ICON",
          "P3 Num Circle 3  A3 **INVALID ICON",
          "P4 Num Circle 4  A4 **INVALID ICON",   # 20
          "P5 Num Circle 5  A5 **INVALID ICON",
          "P6 Num Circle 6  A6 **INVALID ICON",
          "P7 Num Circle 7  A7 **INVALID ICON",
          "P8 Num Circle 8  A8 **INVALID ICON",
          "P9 Num Circle 9  A9 Gas Station   ",   # 25
          "MR Fire          NR Hail          ",
          "MS Campground    NS Park/Picnic   ",
          "MT Motorcycle    NT Advisory      ",
          "MU Railroad engn NU **INVALID ICON",
          "MV Car           NVzCar           ",   # 30
          "MW File Server   NW Info kiosk    ",
          "MX Hurric predictNX Hurricane     ",
          "PA Aid Station   AAzBox           ",
          "PB BBS           AB Blowing snow  ",
          "PC Canoe         AC Coastguard    ",   # 35
          "PD **INVALID ICONAD Drizzle       ",
          "PE Eyeball       AE Smoke         ",
          "PF **INVALID ICONAF Freezing rain ",
          "PG Grid square   AG Snow shower   ",
          "PH Hotel         AH Haze          ",   # 40
          "PI TCP/IP        AI Rain shower   ",
          "PJ **INVALID ICONAJ Lightning     ",
          "PK School        AK Kenwood       ",
          "PL **INVALID ICONAL Lighthouse    ",
          "PM MacAPRS       AM **INVALID ICON",   # 45
          "PN NTS Station   AN Nav Buoy      ",
          "PO Balloon       AO **INVALID ICON",
          "PP Police        AP Parking       ",
          "PQ **INVALID ICONAQ Earthquake    ",
          "PR Rec Vehicle   AR Restaurant    ",   # 50
          "PS Space Shuttle AS Satellite/PAC ",
          "PT SSTV          AT Thunderstorm  ",
          "PU Bus           AU Sunny         ",
          "PV ATV           AV Vortac Navaid ",
          "PW NWS Site      AWzNWS Site      ",   # 55
          "PX Helicopter    AX Pharmacy Rx   ",
          "PY Yacht         AY **INVALID ICON",
          "PZ WinAPRS       AZ **INVALID ICON",
          "HS Jogger        DS Wall cloud    ",
          "HT DF Triangle   DT **INVALID ICON",   # 60
          "HU PBBS          DU **INVALID ICON",
          "HV Large aircraftDVzAircraft      ",
          "HW WX station    DWzWX station    ",
          "HX Dish antenna  DX Rain          ",
          "LA Ambulance     SAzARRL ARES     ",   # 65
          "LB Bicycle       SB Blowing dust  ",
          "LC **INVALID ICONSCzCivil Defense ",
          "LD Dual Garage   SD DX spot       ",
          "LE Horse         SE Sleet         ",
          "LF Fire truck    SF Funnel Cloud  ",   # 70
          "LG Glider        SG Gale flags    ",
          "LH Hospital      SH Ham Store     ",
          "LI IOTA          SIzIndoor digi   ",
          "LJ Jeep          SJ Work zone     ",
          "LK Truck         SK **INVALID ICON",   # 75
          "LL **INVALID ICONSL Area Symbol   ",
          "LM Mic-repeater  SM Value Signpost",
          "LN Node          SNzTriangle      ",
          "LO EOC           SO Small circle  ",
          "LP Rover (dog)   SP Partly cloudy ",   # 80
          "LQ Grid square   SQ **INVALID ICON",
          "LR Antenna       SR Restrooms     ",
          "LS Ship (power)  SSzShip/Boat     ",
          "LT Truck stop    ST Tornado       ",
          "LU Truck 18wh    SUzTruck         ",   # 85
          "LV Van           SVzVan           ",
          "LW Water Station SW Flooding      ",
          "LX X-APRS Unix   SX **INVALID ICON",
          "LY Yagi at QTH   SY **INVALID ICON",
          "LZ **INVALID ICONSZ **INVALID ICON",   # 90
          "J1 **INVALID ICONQ1 Fog           ",
          "J2 **INVALID ICONQ2 **INVALID ICON",
          "J3 **INVALID ICONQ3 **INVALID ICON",
          "J4 **INVALID ICONQ4 **INVALID ICON"    # 94
          );

$maxSym   = @Sym - 1;


@Phg =    (
          "Omni-directional",         # 0
          "North East",       
          "East",
          "South East",
          "South",
          "South West",               # 5
          "West",
          "North West",
          "North"                     # 9
          );

$maxPhg   = @Pgh;


@Accuracy = (
          "Useless",                  # 0
          "< 240 deg",
          "< 120 deg",
          "< 64 deg",
          "< 32 deg",
          "< 16 deg",                 # 5
          "< 8 deg",
          "< 4 deg",
          "< 2 deg",
          "< 1 deg"                   # 9
          );
          
          
@Aprspath = (
          "Regular Digi (VIA) Path",  # -0
          "WIDE1-1",
          "WIDE2-2",
          "WIDE3-3",
          "WIDE4-4",
          "WIDE5-5",                  # -5
          "WIDE6-6",
          "WIDE7-7",
          "North Path",
          "South Path",
          "East Path",                # -10
          "West Path",
          "North Path + WIDE",
          "South Path + WIDE",
          "East Path + WIDE",
          "West Path + WIDE"          # -15
          );
          
@Mice =   (
          "00S0E",            # 0 [0]
          "10S0E",            # 1
          "20S0E",            # 2
          "30S0E",            # 3
          "40S0E",            # 4
          "50S0E",            # 5 [5]
          "60S0E",            # 6
          "70S0E",            # 7
          "80S0E",            # 8
          "90S0E",            # 9
          "-----",            #   [10]
          "-----", 
          "-----", 
          "-----", 
          "-----", 
          "-----",            #   [15]
          "-----", 
          "0c---",            # A
          "1c---",            # B
          "2c---",            # C
          "3c---",            # D [20]
          "4c---",            # E
          "5c---",            # F
          "6c---",            # G
          "7c---",            # H
          "8c---",            # I [25]
          "9c---",            # J
          " c---",            # K
          " 0S0E",            # L
          "-----",
          "-----",            #   [30]
          "-----",
          "0sN1W",            # P
          "1sN1W",            # Q
          "2sN1W",            # R
          "3sN1W",            # S [35]
          "4sN1W",            # T
          "5sN1W",            # U
          "6sN1W",            # V
          "7sN1W",            # W
          "8sN1W",            # X [40]
          "9sN1W",            # Y
          " sN1W"             # Z
          );

$maxMice  = @Mice;


@Standard = (
          "EMERGENCY",
          "/M6/Priority",
          "/M5/Special",
          "/M4/Committed",
          "/M3/Returning",
          "/M2/In Service",
          "/M1/En Route",
          "/M0/Off Duty"
          );

@Custom = (
          "EMERGENCY",
          "/C6/Custom-6",
          "/C5/Custom-5",
          "/C4/Custom-4",
          "/C3/Custom-3",
          "/C2/Custom-2",
          "/C1/Custom-1",
          "/C0/Custom-0"
          );
          
@Ssid =   (0,65,53,70,66,57,56,7,83,30,28,47,74,50,75,86);

@Tsource = (
          "Other",                    # 00
          "GLL",                      # 01
          "GGA",                      # 10
          "RMC"                       # 11
          );
          
@Torigin = (
          "Compressed",               # 000
          "TNC Beacon Text",          # 001
          "Software Compression",     # 010
          "[tbd]",                    # 011
          "KPC3",                     # 100
          "Pico",                     # 101
          "Other tracker [tbd]",      # 110
          "Digipeater conversion"     # 111
          );
          
          

@Objtype = (
          "Open Circle",              # 0
          "Line (Type 1)",            # 1
          "Open Ellipse",             # 2
          "Open Triangle",            # 3
          "Open Box",                 # 4
          "Color-filled Circle",      # 5
          "Line (Type 6)",            # 6
          "Color-filled Ellipse",     # 7
          "Color-filled Triangle",    # 8
          "Color-filled Box"          # 9
          );

@Objcolor = (
          "Black (high intensity)",   # /0
          "Blue (high intensity)",    # /1
          "Green (high intensity)",   # /2
          "Cyan (high intensity)",    # /3
          "Red (high intensity)",     # /4
          "Violet (high intensity)",  # /5
          "Yellow (high intensity)",  # /6
          "Gray (high intensity)",    # /7
          "Black (low intensity)",    # /8
          "Blue (low intensity)",     # /9
          "Green (low intensity)",    # 10
          "Cyan (low intensity)",     # 11
          "Red (low intensity)",      # 12
          "Violet (low intensity)",   # 13
          "Yellow (low intensity)",   # 14
          "Gray (low intensity)"      # 15
          );
          
@Ambig =  ("", "", "", "", "59.99", "00.00", "9.99", "0.00",
          "", "", "99", "00", "9", "0");

@Uday =   (                       # Day     0 = 30 Dec 1899
          35796,    # 1998  [0]   # Day 36674 = 28 May 2000
          36161,    # 1999
          36526,    # 2000
          36892,    # 2001
          37257,    # 2002
          37622     # 2003  [5]
          );
          
@Umonth = (
          1,        # Jan   [0]
          32,       # Feb   [1]
          60,       # Mar
          91,       # Apr
          121,      # May
          152,      # Jun   [5]
          182,      # Jul
          213,      # Aug
          244,      # Sep
          274,      # Oct
          305,      # Nov   [10]
          335       # Dec
          );
          
          
@Country =  (
          "VE", "NW6540145050",
          "VA", "NW6540145050",
          "ZL", "SE5033179165",
          "VK", "SE4510155110",
          "A",  "NW5015125065",
          "K",  "NW5015125065",
          "N",  "NW5015125065",
          "W",  "NW5015125065"
          );
          
$maxCountry  = @Country;          
 

%Nmea =   ("GGA", "RMC", "GLL", "VTG");

$Nmea{"GGA"} = "&GGA";
$Nmea{"RMC"} = "&RMC";
$Nmea{"GLL"} = "&GLL";
$Nmea{"VTG"} = "&VTG";


%Query =  ("?APRSD", "?APRSH", "?APRSM", "?APRSO", "?APRSP", "?APRSS", "?APRST");

$Query{"?APRSD"}  = " Query for list of stations heard direct.\n";
$Query{"?APRSH"}  = " Query for number of times the station has been heard.\n";
$Query{"?APRSM"}  = " Query for unacknowledged or undelivered messages.\n";
$Query{"?APRSO"}  = " Query for objects.\n";
$Query{"?APRSP"}  = " Query for position.\n";
$Query{"?APRSS"}  = " Query for status.\n";
$Query{"?APRST"}  = " Query for trace \(route\) taken to reach the target.\n";

#################################################################
########################    FORMATS    ##########################
#################################################################

format KENWOOD_DISPLAY =

   TH-D7 Screen 1     TH-D7 Screen 2               TM-D700
 +---------------+  +---------------+   +----------------------------+
 | Dx:@<<<<<<<<  |  | Dx:@<<<<<<<<  |   | 1:@<<<<<<<< @<<<<<<<< @<<<<|
      $resource,         $resource,         $resource,$field_one,$forth
 | @<<<<<<<<     |  |    @<<<<<<<<  |   |                            |
   $field_one,           $field_two
 |         @<<<< |  |    @<<<<<<<<< |   |   @<<<<<<<< @<<<<          |
           $forth,       $field_333,        $field_two, $field_3a
 +---------------+  +---------------+   |   @<<<<                    |
                                            $field_3b
                                        +----------------------------+
.


format EQUATION_COEFFICIENTS =
  Channel A@: Value = @>>>>> *v*v + @>>>>> *v + @<<<<<<<<<<<<<<<<
           $ch,       $vv,          $v,         $c
.

#################################################################
########################   CONSTANTS   ##########################
#################################################################

$ft2mt  = 0.3048;
$mt2ft  = 1/$ft2mt;
$mi2km  = $mph2kph = 1.609344;
$km2mi  = 1/$mi2km;
$mi2nm  = 0.8689762;
$nm2mi  = 1/$mi2nm;
$mph2kt = 0.8689762;
$kt2mph = 1/$mph2kt;
$kt2kph = $nm2km = $kt2mph * $mi2km;
$kt2ms  = 0.514444;
$ms2kt  = 1/$kt2ms;
$mph2ms = 0.44704;
$ms2mph = 1/$mph2ms;
$in2mm  = 25.4;

$x91_2  = 91 * 91;
$x91_3  = 91 * 91 * 91;

#################################################################
########################     MAIN      ##########################
#################################################################

#---------------------------------------------------------------
# GET INPUT AND OUTPUT FILENAMES.
#---------------------------------------------------------------
 
$file_open = 1;

# while (!$file_open) {
#   print ("Input filename:  ");
#   $input_file = <STDIN>; chop ($input_file);
#   
#   if (open(INPUT, $input_file)) {
#     $file_open = 1;
#   } else {
#     print ("**ERROR: Cannot open input file \'$input_file\'.\n\n");
#   }
# }

# print ("Output filename: ");
# $output_file = <STDIN>; chop ($output_file);

# unless (open(OUTPUT, ">$output_file")) { 
#   die ("**ERROR: Cannot open output file \'$output_file\'. Bailing out.\n");
# }


#---------------------------------------------------------------
# GET LINE FROM INPUT FILE.
#---------------------------------------------------------------
 
$record = $maxlinelength = $maxinfolength = 0;

sub DisplayPacket() {
  my $class = shift;
  my $line = shift || '';
  return if ($line eq "");
    
  return if (length($line) == 1);                       # empty line
  
  $ui = 0;
  $u = "";
  $u = ord(substr($line, 16, 1));
   
  if ($u == 0xfe)
    {                                                 # first line of UI-View pair
    return if (substr($line, 17, 5) eq "START");
    
    $ui = 1;
    
    $ui_timestamp = substr($line, 0, 16);
    
    $line = substr($line, 17);
    chop ($line);

    if (index($line, ":") < 0) {$line .= ":";}
     
    $line .= <STDIN>;                                 # append second UI-View line
    }
    
  if (substr($line, 0, 1) eq "#") {
    ($pound, $day, $mon, $mon_day, $time, $tz, $year ) = split ( / /, $line );
    return;
  }
     # comment line

  print STDOUT ("\n--------------------------------------------------------------\n");
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  print STDOUT ("Record #", ++$record, " at ", $time, "\n");

  print STDOUT ("$line");
  
  if (index($line, ":") < 0)
    {
    print STDOUT (" **BAD PACKET. No header. Bailing out.\n");
    return;
    }

  if ($ui)
    {                                                 # UI-View timestamp
    $uday = substr($ui_timestamp, 0, 5);
    if ($uday < $Uday[0] || $uday > $Uday[5])
      {    
      print STDOUT (" UI-View Timestamp= $ui_timestamp\n");
      }
    else
      {
      for ($n=1; $n<6; $n++)
        {
        last if ($uday < $Uday[$n]);
        }
      $uyyyy = 1997 + $n;

      $udy = $uday - $Uday[$n-1] + 1;

      if ($uyyyy == 2000 && $udy > 59)
        {
        $feb29 = 0;
        if ($udy == 60) {$feb29 = 1;}
        $udy -= 1;
        } 
      
      for ($n=1; $n<12; $n++)
        {
        last if ($udy < $Umonth[$n]);
        }

      if ($uyyyy == 2000 && $feb29 == 1)
        {                                             # 29 Feb
        $umm = "Feb";
        $udd = 29;
        }
      else
        {
        $umm = $Month[$n-1];
        $udd = $udy - $Umonth[$n-1] + 1;
        }
                    
      $uhhmmss = substr($ui_timestamp, 5, 11);
      
      $uhh   = int($uhhmmss * 24);
      $ummss = $uhhmmss * 24 - $uhh;
      $umin  = int($ummss * 60);
      $uss   = int(($ummss * 60 - $umin) * 60 + 0.5);
      
      print STDOUT (" UI-View Timestamp= $udd $umm $uyyyy   $uhh hrs $umin mins $uss secs \(PC clocktime\)\n");
      }
    }
  
  if ($maxlinelength < length($line)) {$maxlinelength = length($line);}
  
  
  # Get header. It may contain TNC date and/or timestamp and/or UI packet type, all
  # of which need to be filtered out.
  #
  # AEA format:  'dd-mon-yy  hh:mm:ss  src>digi>dst [UI]:' (or (UI) or <UI>) 
  # TNC2 format: 'src>dst,digi [date_time_in_any_format]: <<UI>>:'
  
  
  if (($i = index($line, ">")) > -1)
    {
    $src_call = substr($line, 0, $i);
  
    if (($i = rindex($src_call, " ")+1) > 0)
      {
      $src_call = substr($src_call, $i);              # remove AEA date/time or other junk
      print STDOUT ("**WARNING: TNC timestamp/junk in header.\n");
      }
    
    $line = substr($line, $i);
    }
    
  $colon = index($line, ":");
  $space = index($line, " ");

  $path = substr($line, 0, $colon);
  
  if ($space > 0)
    {
    if ($space < $colon)
      {                                               # remove other junk downstream from first space
      if (!$ui) {print STDOUT ("**WARNING: Extraneous TNC status information/junk in header.\n");}
      
      $path = substr($line, 0, $space);
      if (($i = substr($line, $space+1, 1)) eq "[")
        {                                             # beginning of AEA [UI] or TNC2 [timestamp]
        $i = $space + 1;
        $j = index($line, "]", $space+1);
        
        $tnctime = substr($line, $i+1, $j-$i-1);      # TNC2 timestamp if no UI
        if (index ($tnctime, "UI") < 0)
          {
          if (!$ui) {print STDOUT ("**WARNING: TNC timestamp in header.\n");}
          }
        else
          {
          if (!$ui) {print STDOUT ("**WARNING: Extraneous TNC status information/junk in header.\n");}
          }
          
        if (substr($line, $j+1, 2) eq ": ")
          {                                           # remove more junk following TNC2 [timestamp]
          $colon = index($line, ":", $j+2);
          if (!$ui) {print STDOUT ("**WARNING: Extraneous TNC status information/junk in header.\n");}
          }
        else
          {
          $colon = $j + 1;
          }
        }
      }
    }

 # At this point, $colon is at the start of the Information field, ready for later.
 
  if (($i = index($path, "/V")) > -1) {$path = substr($path, 0, $i);}
  if (($i = index($path, "/1")) > -1) {$path = substr($path, 0, $i);}
  if (($i = index($path, "/2")) > -1) {$path = substr($path, 0, $i);}

  if (($star = index($src_call, "*")) > 0) {$src_call = substr($src_call, 0, $star);}

  &CHECKCALL($src_call);
  
  $src_ssid = "0";

  if (($minus = index($src_call, "-")) > 0)
    {
    $src_ssid = substr($src_call, $minus+1);
    $src_call = substr($src_call, 0, $minus);
    }
  
  $gt = rindex($path, ">");
  if ($gt > -1)
    {
    $dst_call = substr($path, $gt+1);

    if (($comma = index($dst_call, ",")) > 0) {$dst_call = substr($dst_call, 0, $comma);}
    if (($star  = index($dst_call, "*")) > 0) {$dst_call = substr($dst_call, 0, $star);}
  
    &CHECKCALL($dst_call);
  
    $dst_ssid = "0";
    if (($minus = index($dst_call, "-")) > 0) 
      {
      $dst_ssid = substr($dst_call, $minus+1);
      $dst_call = substr($dst_call, 0, $minus);
      }
    }  
  else
    {
    print STDOUT ("**WARNING: No destination callsign.\n");
    $dst_ssid = $dst_call = "";
    }
 
  $info = substr($line, $colon+1);
 
  if (ord(substr($info, length($info)-1, 1)) < 32) {chop ($info);}
 
  $infolength = length($info);
  
  if ($infolength == 0)
    {                                  # no Information field
    print STDOUT (" \(** Beacon without text, not APRS\)\n");
    return;
    }

  if ($dst_ssid > 0 && $dst_ssid < 16)
    {
    print STDOUT ("**NOTE: Non-zero APRS digipeater path \(encoded in destination SSID\)= $Aprspath[$dst_ssid]\n");
    }

  if ($maxinfolength < $infolength) {$maxinfolength = $infolength;}
  
  
#---------------------------------------------------------------
# START PROCESSING THE DTI. 
# Look for exceptions: !! is Ultimeter WX station
#                      $$ is Ultimeter WX station
#                      $U is Ultimeter WX station
#                      Only T# is telemetry (otherwise a beacon)
#                      ' maps to ` in Kenwood D700
#                      DX Cluster beacon
#                      Message with missing : DTI
#                      Object with missing ; DTI
#                      ! shifted by X1-J header
#---------------------------------------------------------------

  $dti  = ord(substr($info, 0, 1)) - 28;
  if ($dti < 0 || $dti > $maxDti)
    {
    print STDOUT (" **BAD APRS DATA TYPE IDENTIFIER. Bailing out.\n");
    return;
    }
    
  $ch2 = substr($info, 1, 1);
  if ($dti == 5  && $ch2 eq "!")  {$dti = 99 ;}       # !!
  if ($dti == 8  && $ch2 eq "\$") {$dti = 100;}       # $$
  if ($dti == 8  && $ch2 eq "U")  {$dti = 101;}       # $U
  if ($dti == 56 && $ch2 ne "#")  {$dti = 4  ;}       # not T# 

  $ch9 = substr($info, 9, 1);
    
  $radio = "";
  if (($dti == 68 || $dti == 11) && $ch9 eq ">") {$radio = "Kenwood TH-D7";}

  if ($dti == 11 && $ch9 eq "]")
    {
    $radio = "Kenwood TM-D700";
    $dti   = 68;
    }
    
  if (index($Dti[$dti*2], "Beacon") > -1)
    {                                                 # This is apparently a beacon, but ....
    $bang = index($info, "!");   
    
    if (substr($info, 0, 6) eq "DX de ")
      {                                               # DX_CLUSTER (sets $infolength to 0, forcing exit)
      &DX_CLUSTER;
      }
    elsif ($ch9 eq ":")
      {
      print STDOUT ("**NOTE: This may be an APRS Message with the leading \':\' Data Type Identifier missing.\n");
      }
    elsif ($ch9 eq "*" || $ch9 eq "_")
      {
      print STDOUT ("**NOTE: This may be an APRS Object with the leading \';\' Data Type Identifier missing.\n");
      }
    elsif ($bang > 0 && $bang < 40)
      {                                               # ! posit shifted by X1-J header
      $info = substr($info, $bang);
      $dti = 5;
      }
    }  
  
  return if ($infolength < 2);

  print STDOUT (" APRS Data Type= $Dti[$dti*2]\n");
  if ($radio ne "") {print STDOUT (" Radio= $radio\n");}
    
  return if (index($Dti[$dti*2], "Beacon") > -1);       # non-APRS
  
  eval ($Dti[$dti*2+1]);                              # go decode the data (via &Ann)
   
  } # (End of current line)
  
#################################################################
#################################################################
########################               ##########################
########################  SUBROUTINES  ##########################
########################               ##########################
#################################################################
#################################################################



#################################################################
######################## Line Decoding ##########################
#################################################################


#---------------------------------------------------------------
# A28: 0x1c Current Mic-E (Rev 0 beta)
#---------------------------------------------------------------
sub A28
{
&A96;
}


#---------------------------------------------------------------
# A29: 0x1d Old Mic-E (Rev 0 beta)
#---------------------------------------------------------------
 
sub A29
{
&A96;
}


#---------------------------------------------------------------
# A33: ! Posit without time. No APRS
#---------------------------------------------------------------
 
sub A33 
{
&LOCATION(1);
}

#---------------------------------------------------------------
# A35: # Peet Bros U-II WX Station
#---------------------------------------------------------------
 
sub A35
{
if (substr($info, 1) =~ /[^0-9A-Z]+/) 
  {
  print STDOUT ("**WARNING: Data does not look like Peet WX data.\n");
  }

if (!&GPSxxx) {&SSIDSYM;}
}


#---------------------------------------------------------------
# A36: $ Raw GPS NMEA Data
#---------------------------------------------------------------
 
sub A36
{
@Parm     = ("");
@Parm     = split (/,/, $info);
$elements = @Parm;

$star     = rindex($info, "*");
$csum     = hex(substr($info, $star+1));
$cstring  = substr($info, 1, $star-1);
$clength  = length($cstring);

$mycsum   = 0;
for ($n=0; $n<=$clength; $n++)
  {
  $mycsum ^= ord(substr($cstring, $n, 1));
  }

if ($mycsum != $csum)
  {
  print STDOUT ("**WARNING: NMEA checksum error. Data may not decode correctly.\n");
  }

$nmea = substr($Parm[0], 3);
eval ($Nmea{$nmea});                                  # go decode the NMEA sentence
}


#---------------------------------------------------------------
# A37: % Agrelo DF Jr/Microfinder
#---------------------------------------------------------------
 
sub A37
{
if (!&GPSxxx) {&SSIDSYM;}
}


#---------------------------------------------------------------
# A39: ' Old Mic-E Data
#---------------------------------------------------------------
 
sub A39
{
&A96;
}


#---------------------------------------------------------------
# A41: ) Item
#---------------------------------------------------------------
 
sub A41
{
$ilive = index($info, "!");
if ($ilive == -1 || $ilive > 10) {$ilive = 20;}

$ikill = index($info, "_");
if ($ikill == -1 || $ikill > 10) {$ikill = 20;}

$sum = $ilive + $ikill;
$status = "**BAD";

if ($sum == 40)
  {
  print STDOUT ("**WARNING: Item Live/Killed Item status character \(! or _\) missing.\n");
  }
elsif ($sum == 21)
  {
  print STDOUT ("**WARNING: Item Name missing.\n");
  }
elsif ($ilive < $ikill)
  {
  $status = "Live";
  $p = $ilive + 1;
  }
else
  {
  $status = "Killed";
  $p = $ikill + 1;
  }

$commentstart = $p + 13;

$item = substr($info, 1, $p-2);
print STDOUT (" Item Name= \'$item\'  Status= $status\n");

if ($p < 3) {print STDOUT (" **WARNING: Item name too short \(must be 3-9 characters\).\n");}

&LOCATION($p);
  
if ($stid eq "\\" && $scode eq "m") {&SIGNPOST($commentstart);}
}


#---------------------------------------------------------------
# A42: * Peet Bros U-II WX Station
#---------------------------------------------------------------
 
sub A42
{
if (substr($info, 1) =~ /[^0-9A-Z]+/) 
  {
  print STDOUT ("**WARNING: Data does not look like Peet WX data.\n");
  }

if (!&GPSxxx) {&SSIDSYM;}  
}


#---------------------------------------------------------------
# A43: + Shelter Data with time
#---------------------------------------------------------------
 
sub A43
{}


#---------------------------------------------------------------
# A44: , Invalid Data or Test Data
#---------------------------------------------------------------
 
sub A44
{}


#---------------------------------------------------------------
# A46: . Space Weather
#---------------------------------------------------------------
 
sub A46
{}


#---------------------------------------------------------------
# A47: / Posit with time. No APRS
#---------------------------------------------------------------
 
sub A47
{
&TIME7(1);
&LOCATION(8); 
}

#---------------------------------------------------------------
# A58: : Message
#---------------------------------------------------------------
 
sub A58
{
# ?APRSx Query in Message.

$query = substr($info, 11, 6);

if (substr($query, 0, 6) eq "?PING?") {$query = "?APRST";}

$qtype = $Query{$query};

print STDOUT ("$qtype");



# Telemetry Parameters in Message.  

$teleheader = substr($info, 11, 5);

if ($teleheader eq "PARM.")
  {                                                   # PARM.
  print STDOUT (" Telemetry Parameter Names:\n");
  
  @Name = split(/,/, substr($info, 16));
  
  $a1 = substr($Name[ 0], 0, 7);
  $a2 = substr($Name[ 1], 0, 6);
  $a3 = substr($Name[ 2], 0, 5);
  $a4 = substr($Name[ 3], 0, 5);
  $a5 = substr($Name[ 4], 0, 4);
  $b1 = substr($Name[ 5], 0, 5);
  $b2 = substr($Name[ 6], 0, 4);
  $b3 = substr($Name[ 7], 0, 3);
  $b4 = substr($Name[ 8], 0, 3);
  $b5 = substr($Name[ 9], 0, 3);
  $b6 = substr($Name[10], 0, 2);
  $b7 = substr($Name[11], 0, 2);
  $b8 = substr($Name[12], 0, 2);
 
  print STDOUT ("  Analog  Channel: A1= $a1  A2= $a2  A3= $a3  A4= $a4  A5= $a5\n");
  print STDOUT ("  Digital Channel: B1= $b1  B2= $b2  B3= $b3  B4= $b4  B5= $b5  B6= $b6  B7= $b7  B8= $b8\n");
  }
  
elsif ($teleheader eq "UNIT.")  
  {                                                   # UNIT.
  print STDOUT (" Telemetry Analog Units/Digital Labels:\n");
    
  @Name = split(/,/, substr($info, 16));
    
  $a1 = substr($Name[ 0], 0, 7);
  $a2 = substr($Name[ 1], 0, 6);
  $a3 = substr($Name[ 2], 0, 5);
  $a4 = substr($Name[ 3], 0, 5);
  $a5 = substr($Name[ 4], 0, 4);
  $b1 = substr($Name[ 5], 0, 5);
  $b2 = substr($Name[ 6], 0, 4);
  $b3 = substr($Name[ 7], 0, 3);
  $b4 = substr($Name[ 8], 0, 3);
  $b5 = substr($Name[ 9], 0, 3);
  $b6 = substr($Name[10], 0, 2);
  $b7 = substr($Name[11], 0, 2);
  $b8 = substr($Name[12], 0, 2);
   
  print STDOUT ("  Analog Units : A1= $a1  A2= $a2  A3= $a3  A4= $a4  A5= $a5\n");
  print STDOUT ("  Digital Label: B1= $b1  B2= $b2  B3= $b3  B4= $b4  B5= $b5  B6= $b6  B7= $b7  B8= $b8\n");
  }

elsif ($teleheader eq "EQNS.")
  {                                                   # EQNS.
  print STDOUT (" Telemetry Equation Coefficients:\n");
      
  @Name = split(/,/, substr($info, 16));
        
  for ($n=1; $n<15; $n+=3)
    {
    $ch = int($n/3) + 1;
    
    $vv = $Name[$n-1];                                # v^2 coefficient
    if ($vv eq "") {$vv = 0;}
    if ($vv =~ /[^\+\-0-9\.\ ]+/) {$vv = "**BAD";}
    
    $v  = $Name[$n];                                  # v coefficient
    if ($v eq "") {$v = 0;}
    if ($v  =~ /[^\+\-0-9\.\ ]+/) {$v  = "**BAD";}
    
    $c  = $Name[$n+1];                                # constant
    if ($c eq "") {$c = 0;}
    if ($c  =~ /[^\+\-0-9\.\ ]+/) {$c  = "**BAD";}
    
    select(STDOUT);
      $~ = "EQUATION_COEFFICIENTS";
      write;
    select(STDOUT);
    }
  }
  
elsif ($teleheader eq "BITS.")
  {                                                   # BITS.
  @Name = split(/,/, substr($info, 16));
        
  $bits     = $Name[ 0];
  $projname = $Name[ 1];

  print STDOUT (" Telemetry Bit Sense \(asserted level\):\n");
  print STDOUT ("  Digital Channel: ");
  
  for ($n=1; $n<9; $n++)
    {
    $bit = substr($bits, $n-1, 1);
    print STDOUT ("B${n}= $bit  ");
    }
    
  print STDOUT ("\n Project Name= $projname\n");
  }
}



#---------------------------------------------------------------
# A59: ; Object
#---------------------------------------------------------------
 
sub A59
{
$stchar = substr($info, 10, 1);
if ($stchar eq "*")
  {
  $status = "Live";
  }
elsif ($stchar eq "_")
  {
  $status = "Killed";
  }
else
  {
  $status = "(**BAD)";
  print STDOUT (" **WARNING: Live/Killed Object status character \(\* or _\) missing.\n");
  }

$object = substr($info, 1, 9);
if ($object !~ /[^\ -~]{9}/)
  {
  print STDOUT (" Object Name= \'$object\'  Object Status= $status\n");
  }
else
  {
  print STDOUT ("**WARNING: Bad Object name \'$object\'  Object Status= $status\n");
  }

&TIME7(11);
&LOCATION(18);

if ($stid eq "\\" && $scode eq "m") {&SIGNPOST(24);} 
}



#---------------------------------------------------------------
# A60: < Station Capabilities
#---------------------------------------------------------------
 
sub A60
{}


#---------------------------------------------------------------
# A61: = Posit without time. With APRS
#---------------------------------------------------------------
 
sub A61 
{
&LOCATION(1);
}


#---------------------------------------------------------------
# A62: > Status
#---------------------------------------------------------------
 
sub A62
{
if($infolength > 3)
  {
  if (substr($info, 7, 1) eq "z") {&TIME7(1);}        # timestamp
  
  if (substr($info, 7, 1) eq " " || 
      substr($info, 9, 1) eq " " ||
      $infolength == 7           || 
      $infolength == 9              )
    {                                                 # (may be) Maidenhead
    $space = index($info, " ");
    if ($space > -1)
      {
      $last = $space - 1;
      }
    else
      {
      $last = $infolength - 1;
      }
 
    $grid = substr($info, 1, $last-2);
    
    if (&MAIDENHEAD($grid))
      {
      $stid  = substr($info, $last-1, 1);
      $scode = substr($info, $last,   1);
    
      &SYMBOL($stid, $scode);
      }
    }
    
  $carat = substr($info, $infolength-3, 1);           # beam heading/erp
  
  if ($carat eq "^")
    {
    print STDOUT (" Beam Heading= ");
    $heading = substr($info, $infolength-2, 1);
    if ($heading !~ /[0-9A-Z]/) {print STDOUT (" **BAD BEAM HEADING CHARACTER \'$heading\'  ");}
    
    if ($heading =~ /[0-9]/)    {$heading = (ord($heading)-48)*10;}
    if ($heading =~ /[A-Z]/)    {$heading = (ord($heading)-55)*10;}
    
    print STDOUT ("$heading deg   ERP= ");
    
    $erp = substr($info, $infolength-1);
    if ($erp !~ /[1-K]/)  
      {
      print STDOUT (" **BAD ERP CODE \'$erp\'\n");
      }
    else
      {
      $erp = ((ord($erp)-48)**2) * 10;
      print STDOUT ("$erp watts\n");
      }
    }
  }
}


#---------------------------------------------------------------
# A63: ? Query
#---------------------------------------------------------------
 
sub A63
{
if (substr($info, 0, 6) eq "?APRS?")
  {
  print STDOUT (" General all-stations query.\n");
  
  if (index($info, ",") > -1)
    {                                                 # Query addressed to specific target area
    @Target = split(/,/, substr($info, 6));
        
    $lat    = $Target[0];
    $long   = $Target[1];
    $radius = $Target[2];
  
    if ($lat ne "")
      {
      $ns = "N";
      $ew = "E";
      if ($lat  < 0) 
        {
        $ns   = "S";
        $lat  = -$lat;
        }
      if ($long < 0)
        {
        $ew   = "W";
        $long = -$long;
        }
    
      $latdeg  = int($lat);
      $latmin  = sprintf("%6.2f", ($lat - $latdeg)   * 60); $latmin  =~ s/ //g;
    
      $longdeg = int($long);
      $longmin = sprintf("%6.2f", ($long - $longdeg) * 60); $longmin =~ s/ //g;
  
      $radiusk = sprintf("%8.1f", $radius * $mi2km); $radiusk =~ s/ //g; 
    
      print STDOUT (" Target Footprint: \n");
      print STDOUT (" Center: Lat= $latdeg deg $latmin min $ns  Long= $longdeg deg $longmin min $ew\n");
      print STDOUT (" Radius: $radius miles \($radiusk km\)\n"); 
      }
    }                                                 # (End of query to specific target area)
  }                                                   # (End ?APRS?)
  
elsif (substr($info, 0, 7) eq "?IGATE?")
  {
  print STDOUT (" General query for IGate Station Capabilities.\n");
  }

elsif (substr($info, 0, 4) eq "?WX?")
  {
  print STDOUT (" General query for WX reports.\n");
  }

else
  {
  print STDOUT ("**BAD APRS Query.\n");
  }
}


#---------------------------------------------------------------
# A64: @ Posit with time. With APRS
#---------------------------------------------------------------
 
sub A64 
{
&TIME7(1);
&LOCATION(8);
}


#---------------------------------------------------------------
# A84: T Telemetry
#---------------------------------------------------------------
 
sub A84
{
$serial = substr($info, 2, 3);

print STDOUT (" Telemetry Report Sequence No= $serial\n");

if (substr($info, 5, 1) eq ",")
  {
  $data = substr($info, 6);
  }
else
  {                                                   # no comma between serial # and first analog value
  $data = substr($info, 5);
  print STDOUT ("**WARNING: No comma after sequence number -- this format is obsolete.\n");
  }

@Value = split(/,/, $data);
  
for ($n=1; $n<6; $n++)                                # analog
  {
  $value = $Value[$n-1];

  if ($value !~ /[012][0-9][0-9]/ || $value > 255)
    {
    print STDOUT (" Analog Ch${n}= **BAD value \'$value\'\n");
    }
  else
    {
    $hex = sprintf("%x", $value);
    
    print STDOUT (" Analog Ch${n}= 0x$hex \($value decimal\)\n");
    }
  }

$value = substr($Value[5], 0, 8);                     # digital

if ($value !~ /[01]{8}/)
  {
  print STDOUT (" Digital Ch= **BAD value \'$value\'\n");
  }
else
  {
  print STDOUT (" Digital Ch= $value\n");
  }
}


#---------------------------------------------------------------
# A91: [ Maidenhead Grid Square
#---------------------------------------------------------------
 
sub A91
{
$grid = "";
$grid = substr($info, 1, 6);
if (substr($grid, 4, 1) eq "]") {$grid = substr($grid, 0, 4);}

if (&MAIDENHEAD($grid))
  {
  print STDOUT ("**NOTE: This Maidenhead format with square brackets is obsolete.\n");
  }
else  
  {
  print STDOUT ("**WARNING: Invalid locator value.\n");
  }
}


#---------------------------------------------------------------
# A95: _ Positionless Weather Station
#---------------------------------------------------------------
 
sub A95
{
&TIME8(substr($info, 1, 8));

if (($i = index($info, "c")) > -1)
  {
  $direction = substr($info, $i+1, 3);
  &COURSE($direction, "W");
  }
else
  {
  print STDOUT (" **MISSING WIND DIRECTION \'c\' parameter\n");
  }
  
if (($i = index($info, "s")) > -1)
  {
  $speed = substr($info, $i+1, 3);
  &SPEEDM($speed);
  }
else
  {
  print STDOUT (" **MISSING SPEED \'s\' parameter\n");
  }
  
if (($i = index($info, "g")) > -1) {&WX($i);}  

}


#---------------------------------------------------------------
# A96: ` Current Mic-E Data
#---------------------------------------------------------------

sub A96
{

# Destination Address: Latitude, Message Code, N/S, Offset, E/W

$y = "0000.00";

for ($n=0; $n<6; $n++) 
  {
  $c = ord(substr($dst_call, $n, 1)) - 48;
  substr($y, $n, 1)    = substr($Mice[$c], 0, 1);
  
  if ($n == 0) {$messA  = substr($Mice[$c], 1, 1);}
  if ($n == 1) {$messB  = substr($Mice[$c], 1, 1);}
  if ($n == 2) {$messC  = substr($Mice[$c], 1, 1);}
  if ($n == 3) {$ns     = substr($Mice[$c], 2, 1);}
  if ($n == 4) {$offset = substr($Mice[$c], 3, 1) * 100;}
  if ($n == 5) {$ew     = substr($Mice[$c], 4, 1);}
  }
  
substr($y, 5, 2) = substr($y, 4, 2);
substr($y, 4, 1) = ".";

$standard = $custom = 0;
$m = 0;

if ($messA eq "s")
  {
  $standard = 1;
  $m = 4;
  }
if ($messA eq "c")
  {
  $custom = 1;
  $m = 4;
  }
  
if ($messB eq "s")
  {
  $standard = 1;
  $m = $m + 2;
  }
if ($messB eq "c")
  {
  $custom = 1;
  $m = $m + 2;
  }  
  
if ($messC eq "s")
  {
  $standard = 1;
  $m = $m + 1;
  }
if ($messC eq "c")
  {
  $custom = 1;
  $m = $m + 1;
  }  

if ($standard == 1 && $custom == 1)
  {
  print STDOUT (" Message Type= Unknown \(Code contains mixture of standard and custom \'1\' bits\)\n");
  }
else
  {
  if ($standard)
    {
    print STDOUT (" Message Type= $Standard[$m]\n");
    }
  else
    {
    print STDOUT (" Message Type= $Custom[$m]\n");
    }
  }


# Information Field: Longitude, Course, Speed

if ($infolength > 8)
  {
  
  $x = "00000.00";
  
  $xd = ord(substr($info, 1, 1)) - 28 + $offset;
  if ($xd > 179 && $xd < 190) {$xd -= 80;}
  if ($xd > 189 && $xd < 200) {$xd -= 190;}
  substr($x, 0, 3) = sprintf("%03d", $xd);
  
  $xm = ord(substr($info, 2, 1)) - 28;
  if ($xm > 59) {$xm = $xm - 60;}
  substr($x, 3, 2) = sprintf("%02d", $xm);
  
  $xh = ord(substr($info, 3, 1)) - 28;
  substr($x, 6, 2) = sprintf("%02d", $xh);
  
  &POSIT($y, $ns, $x, $ew);
  
  $stid = substr($info, 8, 1);  $scode = substr($info, 7, 1);
  &SYMBOL($stid, $scode);
  
  $dc     = ord(substr($info, 5, 1)) -28;
  $speed  = int($dc/10);
  
  $course = ($dc - $speed * 10) * 100;
  
  $speed  += (ord(substr($info, 4, 1)) - 28) * 10;
  $course +=  ord(substr($info, 6, 1)) - 28;
  
  if ($speed  > 799) {$speed  -= 800;}
  if ($course > 399) {$course -= 400;}
  
  &COURSE($course);
  &SPEEDK($speed);
  &ALT_A(9);
  &ALT_M(9);
  
# Telemetry

  $tflag = substr($info, 9, 1);
  $tdata = substr($info, 10);
  
  if ($tflag eq "`")
    {                                                 # 2 hex channels
    print STDOUT (" Telemetry data:\n");
    
    for ($n=1; $n<6; $n+=4)
      {
      $chan = $n/2 + 0.5;
      $hex  = substr($tdata, $n-1, 2);
      if ($hex =~ /[0-9A-Fa-f]{2}/)
        {
        $dec = hex($hex);
        print STDOUT ("  Ch${chan}= 0x$hex \($dec decimal\)\n");
        }
      else
        {
        print STDOUT ("  Ch${chan}= **BAD hex value \'$hex\'\n");
        }
      }
    }
      
  elsif ($tflag eq "\'")
    {                                                 # 5 hex channels
    print STDOUT (" Telemetry data:\n");
    
    for ($n=1; $n<10; $n+=2)
      {
      $chan = $n/2 + 0.5;
      $hex  = substr($tdata, $n-1, 2);
      if ($hex =~ /[0-9A-Fa-f]{2}/)
        {
        $dec = hex($hex);
        print STDOUT ("  Ch${chan}= 0x$hex \($dec decimal\)\n");
        }
      else
        {
        print STDOUT ("  Ch${chan}= **BAD hex value \'$hex\'\n");
        }
      }
    }  

  elsif (ord($tflag) == 0x1d)
    {                                                 # 5 binary channels (Rev 0 beta unit)
    print STDOUT (" Telemetry data \(Rev 0 beta unit\):\n");
    
    for ($n=1; $n<6; $n++)
      {
      $dec = ord(substr($tdata, $n-1, 1));
      $hex = sprintf("%x", $dec);
      
      print STDOUT ("  Ch${n}= 0x$hex \($dec decimal\)\n");
      }
    }  
  
  
# Maidenhead

  $typecode = substr($info, 9, 1);
  $comment  = substr($info, 9);

  if ($typecode eq ">" || $typecode eq "]") {$comment = substr($info, 10);}
  
  if (($grid = index($comment, "/G")) > 3)
    {
    $mlength = $grid;
    
    if (($space = rindex(substr($comment, 0, $grid), " ")) > -1) {$mlength = $grid - $space - 1;}
    
    if ($grid >= $mlength) {&MAIDENHEAD(substr($comment, $grid-$mlength, $mlength));}
    }
  }                                                   # (End good packet)
  
else
  {                                                   # Bad packet (Info field too short)
  $x = "?????.??";
  &POSIT($y, $ns, $x, $ew);
  print STDOUT (" **BAD Information field < 9 chars. Bailing out.\n");
  }
}


#---------------------------------------------------------------
# A123: { User-defined Packet
#---------------------------------------------------------------
 
sub A123
{}


#---------------------------------------------------------------
# A125: } Third-Party Traffic
#---------------------------------------------------------------
 
sub A125
{}


#---------------------------------------------------------------
# A127: !! Ultimeter WX Station
#---------------------------------------------------------------
 
sub A127
{
if (substr($info, 2) =~ /[^0-9A-Z\-]+/) 
  {
  print STDOUT ("**WARNING: Data does not look like Ultimeter WX data.\n");
  }

if (!&GPSxxx) {&SSIDSYM;}
}


#---------------------------------------------------------------
# A128: $$ Ultimeter WX Station
#---------------------------------------------------------------
 
sub A128
{
if (substr($info, 2) =~ /[^0-9A-F\-]+/) 
  {
  print STDOUT ("**WARNING: Data does not look like Ultimeter WX data.\n");
  }

if (!&GPSxxx) {&SSIDSYM;}
}



#---------------------------------------------------------------
# A129: $U Ultimeter WX Station
#---------------------------------------------------------------
 
sub A129
{
if (substr($info, 1) =~ /[^0-9A-Z\-]+/) 
  {
  print STDOUT ("**WARNING: Data does not look like Ultimeter WX data.\n");
  }

if (!&GPSxxx) {&SSIDSYM;}
}



#################################################################
########################    Common     ##########################
#################################################################


#---------------------------------------------------------------
# CHECKCALL. $1=callsign-SSID
#---------------------------------------------------------------
 
sub CHECKCALL 
{
($callsign) = @_;

$call = $callsign;
$ssid = "";

$minus = index($callsign, "-");
if ($minus > -1)
  {
  $call = substr($callsign, 0, $minus);
  $ssid = substr($callsign, $minus+1);
  }

$lc = length($call);
$ls = length($ssid);

if (substr($call, $lc-1, 1) eq "*") {chop($call);}
if (substr($call, $ls-1, 1) eq "*") {chop($ssid);}

if ($call !~ /[^A-Z0-9]/ && $lc > 0 && $lc <= 6)
  {
  }
else  
  {
  print STDOUT ("**WARNING: Invalid callsign \'$call\'.\n");
  }

if ($call eq "NOCALL" || $call =~ /WIDE[0-7]*/ || $call =~ /TRACE[0-7]*/)
  {
  print STDOUT ("**WARNING: Invalid callsign \'$call\'.\n");
  }

if ($ls > 0)
  {
  if ($ssid !~ /[^0-9]/ && $ssid >= 0 && $ssid <= 15)
    {
    }
  else
    {
    print STDOUT ("**WARNING: Invalid SSID in callsign \'$call-$ssid\'.\n");
    }
  }  
}


#---------------------------------------------------------------
# LOCATION. $1=position in $info of first character of location
#  (first char of location is digit if uncompressed, non-digit if compressed)
#---------------------------------------------------------------
 
sub LOCATION 
{
($p) = @_;

$altp = $p + 19;

if (substr($info, $p, 1) =~ /[0-9]/)
  {                                                   # uncompressed
  $lat  = substr($info, $p,   7); $ns = substr($info, $p+7,  1);
  $long = substr($info, $p+9, 8); $ew = substr($info, $p+17, 1);
  &POSIT($lat, $ns, $long, $ew);

  $stid  = substr($info, $p+8, 1);  
  $scode = substr($info, $p+18, 1);
  
  &SYMBOL($stid, $scode);

  $desc = "";
  if ($scode eq "_" || $scode eq "@") {$desc = "W";}
  &EXTENSION($p+19, $desc);

  &ALT_A($altp);
  &ALT_M($altp);
  }
else
  {                                                   # compressed
  if ($infolength > 13)
    {
    &DECOMPRESS($p+1);

    $stid = substr($info, $p-1, 1);  $scode = substr($info, $p+8, 1);
    &SYMBOL($stid, $scode, 1);
    }
  }
}  
  
  
  
#---------------------------------------------------------------
# POSIT. $1=lat $2=N/S $3=long $4=E/W
#---------------------------------------------------------------
 
sub POSIT 
{
($lat, $ns, $long, $ew) = @_;
          
$goodlat = $goodlong = $countryok = 1;
$ambig = -1;

$llat = length($lat);
for ($n=0; $n<$llat; $n++)
  {
  if (substr($lat, $n, 1) !~ /[0-9\. ]/)   {$goodlat = 0;}
  }
  
if (index($lat, ".") != 4) {$goodlat = 0;}
if ($lat > 9000) {$goodlat = 0;}

$latdeg = sprintf("%d", substr($lat, 0, 2));
$latmin = substr($lat, 2);

if ($latmin >= 60) {$goodlat = 0;}

if ($ns ne "N" && $ns ne "S") {$goodlat = 0;}
  
$llong  = length($long);
for ($n=0; $n<$llong; $n++)
  {
  if (substr($long, $n, 1) !~ /[0-9\. ]/)  {$goodlong = 0;}
  }
  
if (index($long, ".") != 5) {$goodlong = 0;}
if ($long > 18000) {$goodlong = 0;}

$longdeg  = sprintf("%d", substr($long, 0, 3));
$longmin  = substr($long, 3);
if ($longmin >= 60) {$goodlong = 0;}

if ($ew ne "E" && $ew ne "W") {$goodlong = 0;}


$ambig = index($lat, " ");
if ($ambig == 0 || $ambig == 1) {$goodlat = 0;}

$corner[0] = $corner[1] = "";
if ($ambig > 1)
  {
  print STDOUT (" Ambiguous position. Opposite corners of bounding box:\n");}
  $corner[0] = " " . $ns . $ew . " Corner:";
  
  $bottom1 = "S";
  if ($ns eq "S") {$bottom1 = "N";}
  $bottom2 = "E";
  if ($ew eq "E") {$bottom2 = "W";}

  $corner[1] = " " . $bottom1 . $bottom2 . " Corner:";
  

$a = 0;
while ($a < 2)                                        # go round twice if ambiguous
  {
  if ($ambig > 1)                                     # ambiguous posit. replace the ambiguous digits
    {
    $la = length($Ambig[$ambig*2+$a]);
    substr($latmin, 5-$la, $la) = $Ambig[$ambig*2+$a];
    
    $la = length($Ambig[$ambig*2+$a]);
    substr($longmin, 5-$la, $la) = $Ambig[$ambig*2+$a];   
    
    print STDOUT (" $corner[$a]");
    }
  
  print STDOUT (" Lat= ");

  if ($goodlat)
    {
    if ($latdeg == 0 && $latmin == 0 && $longdeg == 0 && $longmin == 0)
      {
      print STDOUT ("\(Indeterminate\)");
      }
    else
      {
      print STDOUT ("$latdeg deg $latmin min $ns");
      
      $foundcountry = 0;
      
      for ($n=0; $n<$maxCountry; $n+=2)
        {
        $lc = length($Country[$n]);
        
        if (substr($src_call, 0, $lc) eq $Country[$n])
          {
          $foundcountry = 1;
          
          $coords  = $Country[$n+1];
          $north   = substr($coords, 0, 1);
          $east    = substr($coords, 1, 1);
          $maxlat  = substr($coords, 2, 2);
          $minlat  = substr($coords, 4, 2);
          $maxlong = substr($coords, 6, 3);
          $minlong = substr($coords, 9, 3);
      
          if ($ns ne $north || $latdeg > $maxlat || $latdeg < $minlat) {$countryok = 0;}

          last;
          }
        }
      }
    }  
  else
    {
    print STDOUT ("**BAD LAT");
    }
  
  print STDOUT ("  Long= ");

  if ($goodlong)
    {
    if ($latdeg == 0 && $latmin == 0 && $longdeg == 0 && $longmin == 0)
      {
      print STDOUT ("\(Indeterminate\)\n");
      }
    else
      {
      print STDOUT ("$longdeg deg $longmin min $ew\n");
    
      if ($foundcountry)
        {
        if ($ew ne $east || $longdeg > $maxlong || $longdeg < $minlong) {$countryok = 0;}
        }
      }
    }  
  else
    {
    print STDOUT ("**BAD LONG\n");
    }
    
  $a++;
  
  last if ($ambig == -1);
  }
  
if (!$countryok && $dti != 13 && $dti != 31)          # ignore posit if with Item or Object 
  {
  print STDOUT ("**QUESTION: Is this lat/long position reasonable?\n");
  print STDOUT ("            It seems a long way from home for this callsign.\n");
  
 # print STDOUT ("N= $n  COUNTRY= $Country[$n]  COORDS= $coords \n
 # NS= $ns NORTH= $north $latdeg $maxlat $minlat\n
 # EW= $ew EAST= $east $longdeg $maxlong $minlong\n");
  
  }  
}


#---------------------------------------------------------------
# DECOMPRESS. $1=position of first compressed posit char in $info
#---------------------------------------------------------------
 
sub DECOMPRESS 
{
($p) = @_;

$good = 1;

$yyyy = substr($info, $p,    4);
$y1   = ord(substr($yyyy, 0, 1)) - 33;
$y2   = ord(substr($yyyy, 1, 1)) - 33;
$y3   = ord(substr($yyyy, 2, 1)) - 33;
$y4   = ord(substr($yyyy, 3, 1)) - 33;

$xxxx = substr($info, $p+4,  4);
$x1   = ord(substr($xxxx, 0, 1)) - 33;
$x2   = ord(substr($xxxx, 1, 1)) - 33;
$x3   = ord(substr($xxxx, 2, 1)) - 33;
$x4   = ord(substr($xxxx, 3, 1)) - 33;

$c    = substr($info, $p+9,  1);
$s    = substr($info, $p+10, 1);
$t    = substr($info, $p+11, 1);

#print STDOUT ("YYYY= $yyyy  $y1 $y2 $y3 $y4  XXXX= $xxxx $x1 $x2 $x3 $x4  C= $c  S= $s  T= $t\n");

# Compute lat/long

$lat  =   90 - ($y1*$x91_3 + $y2*$x91_2 + $y3*91 + $y4) / 380926;

if ($lat > 90 || $lat < -90) 
  {
  print STDOUT (" Lat= **BAD LAT >90 deg\n");
  $good = 0;
  }
  
$long = -180 + ($x1*$x91_3 + $x2*$x91_2 + $x3*91 + $x4) / 190463;

if ($long > 180 || $long < -180)
  {
  print STDOUT (" Long= **BAD LONG >180deg\n");
  $good = 0;
  }

#print STDOUT ("LAT= $lat  LONG= $long\n");

$ns = "N";
if ($lat < 0)
  {
  $ns = "S";
  $lat = -$lat;
  }
  
$ymin   = ($lat  - int($lat)) * 60;
$ymind  = ($ymin - int($ymin)) * 100;

$y    = "0000.00";

substr($y, 0, 2) = sprintf("%02d", int($lat));
substr($y, 2, 2) = sprintf("%02d", int($ymin));
substr($y, 5, 2) = sprintf("%02d", int($ymind));

$ew = "E";
if ($long < 0)
  {
  $ew = "W";
  $long = -$long;
  }

$xmin   = ($long - int($long)) * 60;
$xmind  = ($xmin - int($xmin)) * 100;

$x      = "00000.00";

substr($x, 0, 3) = sprintf("%03d", int($long));
substr($x, 3, 2) = sprintf("%02d", int($xmin));
substr($x, 6, 2) = sprintf("%02d", int($xmind));

#print STDOUT ("Y= $y  X= $x\n");

if ($good) {&POSIT($y, $ns, $x, $ew);}


# Compute course/speed/radio range/altitude (cs)
# Check T-byte first for GGA altitude.

if ($c ne " ")
  {                                                   # s and T contain data
  $nmeasource = "";
  
  if (ord($t) < 97)                                   # T-byte
    {                                                 # OK: Bits 7 and 6 of T are zero
    $t = ord($t) - 33;
    $gpsfix = $t & 0x20;
  
    if ($gpsfix)
      {
      print STDOUT (" GPS Fix= Current   ");
      }
    else
      {
      print STDOUT (" GPS Fix= Old \(last\)   ");
      }
  
    $nmeasource = $Tsource[($t >> 3) & 0x3];
    print STDOUT ("NMEA Source= $nmeasource   ");

    $comporigin = $Torigin[$t & 0x7];
    print STDOUT ("Compression Origin= $comporigin\n");
    
    if ($nmeasource eq "GGA")
      {                                               # cs contains GGA altitude
      $c    = ord($c) - 33;
      $s    = ord($s) - 33;
      $cs   = $c * 91 + $s;
    
      $alt  = int(1.002 ** $cs);
      $altm = sprintf("%8.1f", $alt * $ft2mt);  $altm =~ s/ //g;
      
      print STDOUT (" Altitude= $alt feet \($altm meters\)\n");
      }
    }                                                 # (End good T byte)
  else
    {                                                 # Bits 7 and 6 of T are non-zero
    print STDOUT (" **BAD T-BYTE \'$t\'\n");
    }

  if ($nmeasource ne "GGA")
    {                                                 # cs contains course/speed or radio range
    $good = 1;
                              
    if ($c =~ /[!-z]/)
      {                                               # course/speed
      $c = ord($c) - 33;
      if ($c < 0 || $c > 90)
        {
        print STDOUT (" **BAD COURSE\n");
        $good = 0;
        }
      $s = ord($s) - 33;
    
      if ($good) {&COURSE($c * 4);}
   
      $speed = int(1.08**$s -1 + 0.5);
    
      &SPEEDK($speed);
      }                                               # (End course/speed)
      
    elsif ($c eq "{")
      {                                               # radio range
      $s = ord($s) - 33;    
    
      $range  = sprintf("%7.1f", 2 * 1.08**$s); $range =~ s/ //g;
      $rangek = sprintf("%7.1f", $range * $mi2km); $rangek =~ s/ //g;
    
      print STDOUT (" Pre-Calculated Radio Range= $range miles \($rangek km\)\n");
      }                                               # (End radio range)
    }                                                 # (End course/speed/radio range)  
  }                                                   # (End s and T contain data)
  

# Check for possible false decoding. It may be a corrupted regular posit, with "N/S" and "W/E" separated by 10 chars

$n = index($info, "N", $p) + index($info, "S", $p) + 1;

if ($n > 0)
  {
  $w = substr($info, $n+10, 1);
  if ($w eq "W" || $w eq "E")
    {
    print STDOUT ("**NOTE: This was decoded as a *compressed* posit, but it may be a corrupted *uncompressed* posit.\n");
    }
  }  
}


#---------------------------------------------------------------
# TIME7. (DHM or HMS)  $1=char position of first time digit
#---------------------------------------------------------------
  
sub TIME7 
{
($p) = @_;

$time = substr($info, $p, 6);
$z    = substr($info, $p+6, 1);

$day = $hour = $min = $sec = 0;

$good = 1;
for ($n=0; $n<6; $n++)
  {
  if (substr($time, $n, 1) !~ /[0-9]/) {$good = 0;}
  }

$zone = "UTC";

if ($z eq "z" || $z eq "/")
  {
  $day  = substr($time, 0, 2);
  if ($day < 1 || $day > 31)      {$good = 0;}
  
  $hour = substr($time, 2, 2);
  if ($hour < 0 || $hour > 23)    {$good = 0;}
  
  $min  = substr($time, 4, 2);
  if ($min < 0 || $min > 59)      {$good = 0;}
  
  if ($z eq "/") {$zone = "Local";}
  
  if ($good) {print STDOUT (" Day= $day  Time= $hour hours $min mins $zone\n");}
  }

elsif ($z eq "h")
  {
  $hour = substr($time, 0, 2);
  if ($hour < 0 || $hour > 23)    {$good = 0;}
  
  $min  = substr($time, 2, 2);
  if ($min < 0 || $min > 59)      {$good = 0;}
  
  $sec  = substr($time, 4, 2);
  if ($sec < 0 || $sec > 59)      {$good = 0;}
  
  if ($good) {print STDOUT (" Time= $hour hours $min mins $sec secs UTC\n");}
  }

else
  {
  $good = 0;
  }
  
if (!$good) {print STDOUT ("**WARNING: Bad/missing timestamp. Rest of data may not decode correctly.\n");}
}


#---------------------------------------------------------------
# TIME8. (MDHM)  $1=8-character day/time
#---------------------------------------------------------------
 
sub TIME8 
{
($time) = @_;

$month = $day = $hour = $min = 0;

$good = 1;
for ($n=0; $n<8; $n++)
  {
  if (substr($time, $n, 1) !~ /[0-9]/) {$good = 0;}
  }

$month = substr($time, 0, 2);
if ($month < 1 || $month > 12)  {$good = 0;}

$day  = substr($time, 2, 2);
if ($day < 1 || $day > 31)      {$good = 0;}
  
$hour = substr($time, 4, 2);
if ($hour < 0 || $hour > 23)    {$good = 0;}
  
$min  = substr($time, 6, 2);
if ($min < 0 || $min > 59)      {$good = 0;}
  
if ($good)
  {
  print STDOUT (" Date= $day $Month[$month-1]   Time= $hour hours $min mins UTC\n");
  }
else
  {
  print STDOUT ("**WARNING: Bad/missing timestamp. Rest of data may not decode correctly.\n");
  }
}



#---------------------------------------------------------------
# TIME_NMEA. (HMS[.s])  $1=n-character time
#---------------------------------------------------------------
 
sub TIME_NMEA 
{
($time) = @_;

$hour = $min = $sec = 0;
$good = 1;

$lt = length($time);
if ($lt > 0)
  {
  for ($n=0; $n<$lt; $n++)
    {
    if (substr($time, $n, 1) !~ /[0-9\.]/) {$good = 0;}
    }
  }
  
$hour = substr($time, 0, 2);
if ($hour < 0 || $hour > 23)    {$good = 0;}
 
$min  = substr($time, 2, 2);
if ($min < 0 || $min > 59)      {$good = 0;}
  
$sec  = substr($time, 4);
if ($sec < 0 || $sec > 59)      {$good = 0;}
  
if ($good)
  {
  print STDOUT (" Time= $hour hours $min mins $sec secs UTC\n");
  }
else
  {
  print STDOUT ("**WARNING: Bad/missing timestamp. Rest of data may not decode correctly.\n");
  }
}


#---------------------------------------------------------------
# DATE.  $1=DDMMYY
#---------------------------------------------------------------
 
sub DATE 
{
($date) = @_;

$year = $month = $day = 0;

$good = 1;
for ($n=0; $n<6; $n++)
  {
  if (substr($date, $n, 1) !~ /[0-9]/) {$good = 0;}
  }

$day  = substr($date, 0, 2);
if ($day < 1 || $day > 31)      {$good = 0;}

$month = substr($date, 2, 2);
if ($month < 1 || $month > 12)  {$good = 0;}

$year = substr($date, 4, 2);
if ($year < 0 )   {$good = 0;}
if ($year < 70)
  {
  $year = "20" . $year;
  }
else
  {
  $year = "19" . $year;
  }
  
if ($good)
  {
  print STDOUT (" Date= $day $Month[$month-1] $year  ");
  }
else
  {
  print STDOUT (" **BAD DATESTAMP  ");
  }
}



#---------------------------------------------------------------
# SYMBOL. $1=Symbol Table ID/Overlay  $2=Symbol Code  $3=compressed
#---------------------------------------------------------------
 
sub SYMBOL 
{
($stid, $scode, $compressed) = @_;

print STDOUT (" Icon= ");

$sym  = ord($scode) - 32;

if ($sym < 0 || $sym > $maxSym) {print STDOUT ("**BAD SYMBOL CODE\n");}

if ($stid =~ /[\/\\A-Z0-9a-j]/)
  {
  $symt = 3;
  if ($stid ne "/") {$symt = 20;}
  
  $symtext = substr($Sym[$sym], $symt, 14);   # chop trailing spaces
  while (substr($symtext, length($symtext)-1) eq " ") {chop($symtext);}
    
  print STDOUT ($symtext);
  
  print STDOUT ("   Overlay= ");
  
  if ($stid =~ /[\/\\]/)
    {
    print STDOUT ("\(none\)\n");
    }
  else
    {
    if (substr($Sym[$sym], $symt-1, 1) eq "z")
      {
      $olay = $stid;
      if ($stid =~ /[a-j]/)
        {
        if ($compressed)
          {
          $olay = sprintf("%c", ord($stid)-49);       # numeric overlay on compressed posit
          }
        else
          {
          $olay = "**BAD OVERLAY CHAR \'$stid\' not allowed with uncompressed posit";
          }
        } 
      print STDOUT ("$olay\n");
      }
  else
      {
      print STDOUT ("**BAD OVERLAY CHAR \'$stid\' not allowed with this symbol\n");
      }
    }
  }
else  
  {
  print STDOUT ("**BAD SYMBOL TABLE IDENTIFIER/OVERLAY CHARACTER\n");
  }
}



#---------------------------------------------------------------
# GPSxxx. Returns 1 if GPSxxx symbol found, otherwise 0.
#         Relevant calls are GPSxyz, GPSCnn, GPSEnn
#                            SPCxyz, SYMxyz
#---------------------------------------------------------------
 
sub GPSxxx 
{
$found = 0;

if (length($dst_call) == 5) {$dst_call .= "\\";}

if ($dst_call =~ /GPS[A-S][0-9A-Z][\\0-9A-Z]/  ||
    $dst_call =~ /GPS[CE][0-9]{2}/             ||
    $dst_call =~ /SPC[A-S][0-9A-Z][\\0-9A-Z]/  ||
    $dst_call =~ /SYM[A-S][0-9A-Z][\\0-9A-Z]/    )
  {

  if (substr($dst_call, 0, 4) =~ /GPS[CE]/)
    {                                                 # GPSCnn/GPSEnn
    $nn = substr($dst_call, 4, 2);
    if ($nn > 0 && $nn < $maxSym + 1)
      {
      $found = 1;
      $stid  = "/";
      if (substr($dst_call, 3, 1) eq "E") {$stid = "\\";}
      $scode = sprintf("%c", $nn+32);
      &SYMBOL($stid, $scode);
      }
    }
  else
    {                                                 # GPS/SPC/SYMxyz
    $xy = substr($dst_call, 3, 2);
    
    for ($n=1; $n<$maxSym; $n++)
      {
      $entry = $Sym[$n];
      $prim  = substr($entry, 0,  2);
      $alt   = substr($entry, 17, 2);
      
      if ($xy eq $prim)
        {
        $found = 1;
        $stid  = "/";
        $scode = sprintf("%c", $n+32);
        &SYMBOL($stid, $scode);
        last;
        }
      
      if ($xy eq $alt)
        {
        $found = 1;
        $stid  = substr($dst_call, 5, 1);
        $scode = sprintf("%c", $n+32);
        &SYMBOL($stid, $scode);
        last;
        }
      }  
    }
  return($found);
  }
else
  {
  return(0);
  }
}


#---------------------------------------------------------------
# SSIDSYM. 
#---------------------------------------------------------------

sub SSIDSYM
{
if ($src_ssid >0 && $src_ssid < 16)
  {
  $stid  = "/";
  $scode = sprintf("%c", $Ssid[$src_ssid]+32);
  &SYMBOL($stid, $scode);
  }
}



#---------------------------------------------------------------
# EXTENSION. $1=position of first Data Extension char in $info
#            $2="W" (wind direction)
#            Returns $commentstart (pointing to first char of comment
#            following the extension).
#---------------------------------------------------------------
 
sub EXTENSION
{
($p, $desc) = @_;

$commentstart= $p;

$extn   = substr($info, $p,   7);
$w      = substr($info, $p+7, 1);

$brgrng = substr($info, $p+7, 8);

if ($stid eq "\\" && $scode eq "l")
  {                                                   # Area Object
  $type  = substr($extn, 0, 1);
  $yy    = substr($extn, 1, 2);
  $color = $colcode = substr($extn, 3, 2);
  $xx    = substr($extn, 5, 2);
  
  if ($type =~ /[0-9]/)
    {
    print STDOUT (" Object Type= $Objtype[$type]   ");
    }
  else
    {
    print STDOUT (" Object Type= **BAD Type code \'$type\'   ");
    }
  
  $color =~ s/\//0/;
  
  if ($color > -1 && $color < 16)
    {
    print STDOUT ("Object Color= $Objcolor[$color]\n");
    }
  else
    {
    print STDOUT ("Object Color= **BAD Color code \'$colcode\'\n");
    }
  
  if ($yy =~ /[0-9][0-9]/)
    {
    $latoffsetdeg = ($yy * $yy) / 100; 
    $latoffsetmin = sprintf("%5.2f", ($latoffsetdeg - int($latoffsetdeg)) * 60); $latoffsetmin =~ s/ //g;
    $latoffsetdeg = int($latoffsetdeg);
    
    print STDOUT (" Object Latitude Offset from current position=  $latoffsetdeg deg $latoffsetmin min S\n");
    }
  else
    {
    print STDOUT (" Object Latitude Offset from current position=  **BAD yy value \'$yy\'\n");
    }
    
  if ($xx =~ /[0-9][0-9]/)
    {
    $longoffsetdeg = ($xx * $xx) / 100; 
    $longoffsetmin = sprintf("%5.2f", ($longoffsetdeg - int($longoffsetdeg)) * 60); $longoffsetmin =~ s/ //g;
    $longoffsetdeg = int($longoffsetdeg);
    
    $dirn = "E";
    if ($type == 6) {$dirn = "W";}
  
    print STDOUT (" Object Longitude Offset from current position= $longoffsetdeg deg $longoffsetmin min $dirn\n");
    }
  else
    {
    print STDOUT (" Object Longitude Offset from current position= **BAD xx value \'$xx\'\n");
    }
    
  if ($type == 1 || $type == 6)
    {                                                 # Line corridor
    $comment = substr($info, $p);
    
    $leftb  = index($comment, "{");
    $rightb = index($comment, "}");
    
    if ($leftb > -1 && $leftb < $rightb)
      {
      $miles = substr($comment, $leftb+1, $rightb-$leftb-1);
      $km = sprintf("%8.1f", ($miles * $mi2km)); $km =~ s/ //g;
      
      print STDOUT (" Corridor= $miles miles \($km km\) wide either side of the line.\n");
      }
    }
  }                                                   # (End Area Object)
else
  {                                                   # Non- Area Object
  if ($extn =~ /[\ \.0-3][\ \.0-9]{2}\/[\ \.0-9]{3}/)
    {                                                 # CSE/SPD or DIR/SPD
    $commentstart = $p + 7;
    &COURSE(substr($extn, 0, 3), $desc);
    &SPEEDK(substr($extn, 4, 3));

    if ($desc eq "W")
      {                                               # WX/Storm data
      if ($w eq "g" || $w eq "/") {&WX($p+7);}
      }
    
    elsif ($stid eq "/" && $scode eq "\\" && $brgrng =~ /\/[\ \.0-3][\ \.0-9]{2}\/[0-9]{3}/)
      {                                               # /BRG/RNG
      $commentstart = $p + 15;
      print STDOUT (" DF");
      &COURSE(substr($brgrng, 1, 3), "B");    
    
      $n = substr($brgrng, 5, 1);
    
      if ($n != 0)
        {
        $n  = $n * 12.5;
        if ($n > 100) {$n = "Manual Report";}
      
        $r  = 2 ** substr($brgrng, 6, 1);
        $rk = sprintf("%7.1f", $r * $mi2km); $rk  =~ s/ //g;
      
        $q  = $Accuracy[substr($brgrng, 7, 1)];
    
        print STDOUT (" N= $n ");
        if ($n ne "Manual Report") {print STDOUT ("percent hits");}
      
        print STDOUT ("\n Range= $r miles \($rk km\)   Bearing Accuracy= $q\n");
        }
      }                                               # (end /BRG/RNG)      
    }                                                 # (end CSE/SPD DIR/SPD) 
  
  if ($extn =~ /PHG[0-9][0-z][0-9][0-8]/)
    {                                                 # PHG
    $commentstart = $p + 7;
    $p     = substr($extn, 3, 1);
    $power = $p * $p;
    
    $h      = ord(substr($extn, 4, 1)) - 48;    
    $haat   = int((2**$h)*10);
    $haatm  = sprintf("%10.1f", $haat * $ft2mt);   $haatm   =~ s/ //g;
    
    $gain  = substr($extn, 5, 1);
    
    $dir   = $Phg[substr($extn, 6, 1)];
  
    print STDOUT (" Power= $power watt");
    if ($power > 1) {print STDOUT ("s");}
    
    print STDOUT ("   Height above average terrain= $haat feet \($haatm meters\)\n");
      
    print STDOUT (" Gain= $gain dB  ");
  
    $gain  = 10 **($gain/10);
    $range = sprintf("%8.1f", sqrt(2 * $haat * sqrt(($power/10) * ($gain/2)))); $range =~ s/ //g;
    $rangek= sprintf("%8.1f", $range * $mi2km); $rangek =~ s/ //g;
  
    print STDOUT (" Range Circle= $range miles \($rangek km\)   Directivity= $dir\n");
    }                                                 # (End PHG)
  
  if ($extn =~ /RNG[0-9]{4}/)
    {                                                 # RNG
    $commentstart = $p + 7;
    $range  = int(substr($extn, 3));
    $rangek = sprintf("%8.1f", $range * $mi2km); $rangek =~ s/ //g;
  
    print STDOUT (" Pre-Calculated Radio Range= $range miles \($rangek km\)\n");
    }                                                 # (End RNG)
  
  if ($extn =~ /DFS[0-9]{4}/)
    {                                                 # DFS
    $commentstart = $p + 7;
    $strength = substr($extn, 3, 1);
    
    $h      = ord(substr($extn, 4, 1)) - 48;    
    $haat   = int((2**$h)*10);
    $haatm  = sprintf("%10.1f", $haat * $ft2mt);   $haatm   =~ s/ //g;
       
    $gain   = substr($extn, 5, 1);
        
    $dir    = $Phg[substr($extn, 6, 1)];
    
    print STDOUT (" Strength= $strength S-points");
    print STDOUT ("   Height above average terrain= $haat feet \($haatm meters\)\n");
    print STDOUT (" Gain= $gain dB   Directivity= $dir\n");
    }                                                 # (End DFS)
  }                                                   # (End non-Area Object)
}
  



#---------------------------------------------------------------
# COURSE. $1=Course
#         $2="W" (wind direction) or "B" (bearing)
#---------------------------------------------------------------
sub COURSE
{
($course, $desc) = @_;

$good = 1;

for ($n=0; $n<length($course); $n++)
  {
  if (substr($course, $n, 1) !~ /[\ 0-9\.]/) {$good = 0;}
  }

if ($course < 0 || $course > 360 )  {$good = 0;}

if ($desc eq "W")
  {
  print STDOUT (" Wind Direction= ");
  }
elsif ($desc eq "B")
  {
  print STDOUT (" Bearing = ");
  }
else
  {
  print STDOUT (" Course= ");
  }
  
if ($good)
  {
  $crs = $course;
  if ($desc ne "W")
    {                                                 # non-WX report
    if ($course == 0 || $course eq "..." || $course eq "   ") {$crs = "\(Indeterminate\)";}
    }
  else
    {                                                 # WX report
    if ($course eq "..." || $course eq "   ") {$crs = "\(Indeterminate\)";}
    }
  
  print STDOUT ("$crs deg  ");
  }
else
  {
  print STDOUT ("**BAD COURSE  ");
  }
}



#---------------------------------------------------------------
# SPEEDK. $1=Speed (knots)
#---------------------------------------------------------------
sub SPEEDK
{
($speed) = @_;

$mps  = -1;

$good =  1;
for ($n=0; $n<length($speed); $n++)
  {
  if (substr($speed, $n, 1) !~ /[\ 0-9\.]/) {$good = 0;}
  }

if ($speed < 0)  {$good = 0;}

$mph   = sprintf("%7.1f", $speed * $kt2mph); $mph =~ s/ //g;
$kph   = sprintf("%7.1f", $speed * $kt2kph); $kph =~ s/ //g;
$mps   = sprintf("%7.1f", $speed * $kt2ms ); $mps =~ s/ //g;  # also used in windchill

print STDOUT (" Speed= ");

if ($good)
  {
  if ($speed eq "..." || $speed eq "   ")
    {
    print STDOUT ("\(Indeterminate\)\n");
    }
  else
    {
    print STDOUT ("$speed knots \($mph mph  $kph kph  $mps m/s\)\n");
    }
  }
else
  {
  print STDOUT ("**BAD SPEED   ");
  }
}



#---------------------------------------------------------------
# SPEEDM. $1=Speed (mph)
#---------------------------------------------------------------
sub SPEEDM
{
($speed) = @_;

$mps  = -1;

$good =  1;
for ($n=0; $n<length($speed); $n++)
  {
  if (substr($speed, $n, 1) !~ /[0-9\.]/) {$good = 0;}
  }

if ($speed < 0 || $speed > 999 )  {$good = 0;}

if ($speed eq "..." || $speed eq "   ")
  {
  $speed = "\(Indeterminate\)";
  }
else
  {
  $kph   = sprintf("%7.1f", $speed * $mph2kph); $kph =~ s/ //g;
  $mps   = sprintf("%7.1f", $speed * $mph2ms ); $mps =~ s/ //g;   # also used in windchill
  $knots = sprintf("%7.1f", $speed * $mph2kt ); $knots =~ s/ //g;
  }

print STDOUT (" Speed= ");

if ($good)
  {
  if ($speed eq "\(Indeterminate\)")
    {
    print STDOUT ("$speed\n");
    }
  else
    {
    print STDOUT ("$speed mph \($kph kph  $mps m/s  $knots knots\)\n");
    }
  }
else
  {
  print STDOUT ("**BAD SPEED   ");
  }
}




#---------------------------------------------------------------
# WX.      $1=position in $info of "g" (gust) or "/" (storm type)
#          Also needs wind speed $mps >= 0 for windchill
#---------------------------------------------------------------
sub WX
{
($p) = @_;

$ms = $mps;

$wx = substr($info, $p);

if (substr($wx, 0, 1) eq "g")
  {                                                   # gust
  $gust = substr($wx, 1, 3);
  if ($gust =~ /[0-9]{3}/)
    {
    print STDOUT (" Gust");
    $gust = sprintf("%d", $gust);
    &SPEEDM($gust);
    }
  else
    {
    print STDOUT (" Gust Speed= \(Indeterminate\)\n");
    }
    
  
  if (substr($wx, 4, 1) eq "t")
    {                                                 # temperature
    $temp = substr($wx, 5, 3);
    if ($temp =~ /[\-0-9]{3}/)
      {
      $temp  = sprintf("%d", $temp);
      $tempc = sprintf("%5.1f", ($temp-32)*5/9); $tempc =~ s/ //g;
      
      print STDOUT (" Temp= $temp degF \($tempc degC\)   ");
      
      if ($ms >= 0)
        {                                             # windchill
        $windchill = (0.474266 + 0.453843 * sqrt($ms) - 0.0453843 * $ms) * ($tempc - 33) + 33;
        if ($windchill > $tempc) {$windchill = $tempc;}

        $windchill  = sprintf("%5.1f", $windchill); $windchill =~ s/ //g;
        $windchillf = sprintf("%5.1f", $windchill * 1.8 + 32); $windchillf =~ s/ //g;
        
        print STDOUT ("Windchill= $windchillf degF \($windchill degC\)\n");
        }
      }
    else
      {
      print STDOUT (" Temp= \(Indeterminate\)\n");
      }
    }
  
  $rain = 0;
  $rainlasthr = $rainlast24 = $rainsince00 = "(Indeterminate)";
  
  if (($i = index($wx, "r")) > 0)
    {                                                 # rain
    $rain = 1;
    if (($rainlasthr = substr($wx, $i+1, 3)) =~ /[0-9]{3}/)
      {
      $rainlasthr   = $rainlasthr / 100;
      $rainlasthrmm = sprintf("%6.1f", $rainlasthr * $in2mm); $rainlasthrmm =~ s/ //g;
      }
    else
      {
      $rainlasthr = "(Indeterminate)";
      }
    }
    
  if (($i = index($wx, "p")) > 0)
      {
      $rain = 1;
      if (($rainlast24 = substr($wx, $i+1, 3)) =~ /[0-9]{3}/)
        {
        $rainlast24   = $rainlast24 / 100;
        $rainlast24mm = sprintf("%6.1f", $rainlast24 * $in2mm); $rainlast24mm =~ s/ //g;
        }
      else
        {
        $rainlast24 = "(Indeterminate)";
        }
      }
  
  if (($i = index($wx, "P")) > 0)
      {
      $rain = 1;
      if (($rainsince00 = substr($wx, $i+1, 3)) =~ /[0-9]{3}/)
        {
        $rainsince00   = $rainsince00 / 100;
        $rainsince00mm = sprintf("%6.1f", $rainsince00 * $in2mm); $rainsince00mm =~ s/ //g;
        }
      else
        {
        $rainsince00 = "(Indeterminate)";
        }
      }
  
  if ($rain)
    {
    print STDOUT (" Rain: Last hour= $rainlasthr");
    if ($rainlasthr ne "(Indeterminate)") {print STDOUT (" in \($rainlasthrmm mm\)  ");}
    
    print STDOUT (" Last 24 hrs= $rainlast24");
    if ($rainlast24 ne "(Indeterminate)") {print STDOUT (" in \($rainlast24mm mm\)");}
    print STDOUT ("\n");
    
    print STDOUT ("       Since midnight= $rainsince00");
    if ($rainsince00 ne "(Indeterminate)") {print STDOUT (" in \($rainsince00mm mm\)");}
    print STDOUT ("\n");
    
    } 

  if (($i = index($wx, "h")) > 0)
    {                                                 # humidity
    if (($humidity = substr($wx, $i+1, 2)) =~ /[0-9]{2}/)
      {
      if ($humidity == 0) {$humidity = 100;}
      print STDOUT (" Humidity= $humidity percent   ");
        
      $rh        = log($humidity / 100);              # dew point
      $alpha     = ((17.27 * $tempc) / (237.7 + $tempc)) + $rh;
      $dp        = (237.3 * $alpha) / (17.27 - $alpha);

      $dewpoint  = sprintf("%6.1f", $dp); $dewpoint =~ s/ //g;
      $dewpointf = sprintf("%6.1f", $dp * 1.8 + 32); $dewpointf =~ s/ //g;
        
      print STDOUT ("Dew Point= $dewpointf degF \($dewpoint degC\)\n");
      }
    else
      {
      print STDOUT (" Humidity= \(Indeterminate\)\n");
      }
    }

  if (($i = index($wx, "b")) > 0)
    {                                                 # barometric pressure
    if (($baro = substr($wx, $i+1, 5)) =~ /[0-9]{5}/ && $baro > 7000)
      {
      $baro = $baro / 10;
      print STDOUT (" Barometric Pressure= $baro mbar/hP\n");
      }
    else
      {
      print STDOUT (" Barometric Pressure= \(Indeterminate\)\n");
      }
    }
  }
  
elsif (substr($wx, 0, 1) eq "/")
  {                                                   # storm
  $storm = substr($wx, 1, 2);
  if ($storm eq "TS") {print STDOUT (" Tropical Storm:  ");}
  if ($storm eq "HC") {print STDOUT (" Hurricane:  ");}
  if ($storm eq "TD") {print STDOUT (" Tropical Depression:  ");}
  
  if (($i = index($wx, "/", 1)) > 0)
    {                                                 # sustained wind
    if (($sustwind = substr($wx, $i+1, 3)) =~ /[0-9]{3}/)
      {
      print STDOUT (" Sustained Wind");
      &SPEEDK($sustwind);
      }
    else
      {
      print STDOUT (" Sustained Wind= \(Indeterminate\)   ");
      }
    }

  if (($i = index($wx, "^")) > 0)
    {                                                 # peak wind
    if (($peakwind = substr($wx, $i+1, 3)) =~ /[0-9]{3}/)
      {
      print STDOUT (" Peak Wind");
      &SPEEDK($peakwind);
      }
    else
      {
      print STDOUT (" Peak Wind= \(Indeterminate\)\n");
      }
    }

  if (($i = rindex($wx, "/")) > 0)
    {                                                 # central pressure
    if (($cpress = substr($wx, $i+1, 4)) =~ /[0-9]{4}/)
      {
      $cpress = sprintf("%d", $cpress);
      print STDOUT (" Central Pressure= $cpress mbar/hP\n");
      }
    else
      {
      print STDOUT (" Central Pressure= \(Indeterminate\)\n");
      }
    }

  if (($i = index($wx, ">")) > 0)
    {                                                 # radius hurricane
    if (($radh = substr($wx, $i+1, 3)) =~ /[0-9]{3}/)
      {
      $radh   = sprintf("%d", $radh);
      $radhmi = int($radh * $nm2mi + 0.5);
      $radhkm = int($radh * $nm2km + 0.5);
        
      print STDOUT (" Radius of Hurricane Winds= ");
      print STDOUT ("$radh nautical miles \($radhmi miles  $radhkm km\)\n");
      }
    else
      {
      print STDOUT (" Radius of Hurricane Winds= \(Indeterminate\)\n");
      }
    }
  
  if (($i = index($wx, "&")) > 0)
    {                                                 # radius tropical storm
    if (($radt = substr($wx, $i+1, 3)) =~ /[0-9]{3}/)
      {
      $radt   = sprintf("%d", $radt);
      $radtmi = int($radt * $nm2mi + 0.5);
      $radtkm = int($radt * $nm2km + 0.5);
        
      print STDOUT (" Radius of Tropical Storm Winds= ");
      print STDOUT ("$radt nautical miles \($radtmi miles  $radtkm km\)\n");
      }
    else
      {
      print STDOUT (" Radius of Tropical Storm Winds= \(Indeterminate\)\n");
      }
    }

  if (($i = index($wx, "%")) > 0)
    {                                                 # radius whole gale
    if (($radw = substr($wx, $i+1, 3)) =~ /[0-9]{3}/)
      {
      $radw   = sprintf("%d", $radw);
      $radwmi = int($radw * $nm2mi + 0.5);
      $radwkm = int($radw * $nm2km + 0.5);
        
      print STDOUT (" Radius of Whole Gale Winds= ");
      print STDOUT ("$radw nautical miles \($radwmi miles  $radwkm km\)\n");
      }
    }    
  }
}



#---------------------------------------------------------------
# ALT_A.   $1=position in $info to start looking for "/A="
#---------------------------------------------------------------
sub ALT_A
{
($p) = @_;

$comment = substr($info, $p);

if (($a = index($comment, "/A=")) > -1)
  {
  $alt = substr($comment, $a+3, 6);
  if ($alt =~ /[0-9]{6}/)
    {
    $alt   = int($alt);
    $altm  = int($alt * $ft2mt + 0.5);
      
    print STDOUT (" Altitude= $alt feet \($altm meters\)\n");
    }
  }  
}


#---------------------------------------------------------------
# ALT_M.   $1=position in $info to start looking for "xxx}"
#---------------------------------------------------------------
sub ALT_M
{
($p) = @_;

$comment = substr($info, $p);

if (($a = rindex($comment, "}")) > 0)
  {
  $alt = substr($comment, $a-3, 3);
  
  if (index($comment, "{") == -1)                     # ignore signpost legend and UI-View version #
    {
    $alt  =  (ord(substr($alt, 0, 1)) - 33) * 91 * 91
           + (ord(substr($alt, 1, 1)) - 33) * 91
           + (ord(substr($alt, 2, 1)) - 33)
           - 10000;
           
    $alt  = sprintf("%d", $alt);
    $altf = int($alt * $mt2ft + 0.5);
    
    print STDOUT (" Altitude= $altf feet \($alt meters\)\n");
    }
  }  
}




#---------------------------------------------------------------
# MAIDENHEAD.  $1=grid locator (4 or 6 characters).
#              Returns 1 if valid locator
#---------------------------------------------------------------
sub MAIDENHEAD
{
($grid) = @_;

$short = length($grid);
if ($short == 4) {substr($grid, 4, 2) = "AA";}

if ($grid =~ /[A-R][A-R][0-9][0-9][A-X][A-X]/)
  {
  $ndeg  = -90 + (ord(substr($grid, 1, 1)) - 65) * 10;  
  $ndeg +=       (ord(substr($grid, 3, 1)) - 48);
  $ndeg +=       (ord(substr($grid, 5, 1)) - 65) / 24;
  
  $edeg  = -180 + (ord(substr($grid, 0, 1)) - 65) * 20;  
  $edeg +=        (ord(substr($grid, 2, 1)) - 48) * 2;
  $edeg +=        (ord(substr($grid, 4, 1)) - 65) / 12;

  if ($short == 4)
    {
    $nwlatdeg  = $ndeg + 1;
    $nwlatmin  = 0;
    $nwlongdeg = $edeg;
    $nwlongmin = 0;
    $selatdeg  = $ndeg;
    $selatmin  = 0;
    $selongdeg = $edeg + 2;
    $selongmin = 0;
    }
  else
    {
    $nwlatd    = $ndeg + 1/24;
    $nwlatdeg  = int($nwlatd);
    $nwlatmin  = sprintf("%5.2f",($nwlatd - $nwlatdeg) * 60);    $nwlatmin  =~ s/ //g;
    $nwlongd   = $edeg;
    $nwlongdeg = int($nwlongd);
    $nwlongmin = sprintf("%6.2f",($nwlongd - $nwlongdeg)* 60);   $nwlongmin  =~ s/ //g;
    $selatd    = $ndeg;
    $selatdeg  = int($selatd);
    $selatmin  = sprintf("%5.2f",($selatd - $selatdeg) * 60);    $selatmin  =~ s/ //g;
    $selongd   = $edeg + 1/12; 
    $selongdeg = int($selongd);
    $selongmin = sprintf("%6.2f", ($selongd - $selongdeg) * 60); $selongmin  =~ s/ //g;
    }

  $ns = "N";
  if ($ndeg < 0)
    {
    $ns = "S";
    $nwlatdeg = -$nwlatdeg;
    $nwlatmin = -$nwlatmin;
    $selatdeg = -$selatdeg;
    $selatmin = -$selatmin;
    }
 
  $ew = "E";
  if ($edeg < 0)
   {
   $ew = "W";
   $nwlongdeg = -$nwlongdeg;
   $nwlongmin = -$nwlongmin;
   $selongdeg = -$selongdeg;
   $selongmin = -$selongmin;
   }
 
  print STDOUT (" Maidenhead locator bounding box:\n  NW Corner: ");
  print STDOUT ("Lat= $nwlatdeg deg $nwlatmin min $ns  Long= $nwlongdeg deg $nwlongmin min $ew\n");
  print STDOUT ("  SE Corner: ");
  print STDOUT ("Lat= $selatdeg deg $selatmin min $ns  Long= $selongdeg deg $selongmin min $ew\n");
  
  return (1);
  }
else  
  {
  return (0);
  }
}




#---------------------------------------------------------------
# SIGNPOST     $1= position in $info to start looking for {xxx...}
#---------------------------------------------------------------
sub SIGNPOST
{
($p) = @_;

$comment = substr($info, $p);

$leftb  = index($comment, "{");
$rightb = index($comment, "}");

if ($leftb > -1 && $leftb < $rightb)
  {
  $legend = substr($comment, $leftb+1, $rightb-$leftb-1);
  print STDOUT (" Signpost Legend= \'$legend\'\n");
  }
}


#---------------------------------------------------------------
# DX_CLUSTER.
#              On exit, sets $infolength to 0, forcing immediate 
#              exit from current input line
#---------------------------------------------------------------
sub DX_CLUSTER
{
print STDOUT (" DX Cluster Information:\n");

$dx = substr($info, 16);

$field_one = substr($dx, 0,   9);
$resource  = substr($dx, 10,  9);
$field_two = substr($dx, 23,  9);
$field_333 = substr($dx, 33, 10);
$field_3a  = substr($dx, 33,  5);
$field_3b  = substr($dx, 38,  5);
$forth     = substr($dx, 54,  5);

select(STDOUT);
  $~ = "KENWOOD_DISPLAY";
  write;
select(STDOUT);

$infolength = 0;
}



#################################################################
########################      NMEA     ##########################
#################################################################


#---------------------------------------------------------------
# GGA.
# [0] = $GPGGA    [1] = HMS     [2] = Lat     [3] = N/S
# [4] = Long      [5] = E/W     [6] = Qual    [7] = Sats
# [8] = Hor Dil   [9] = Ant Ht  [10]= M       [11]= Geod Ht
# [12]= M         [13]=         [14]= *Csum

#---------------------------------------------------------------

sub GGA
{
print STDOUT (" Quality Indicator= ");

$qual = $Parm[6];
if ($qual == 0 || $qual eq "") {print STDOUT ("**WARNING: No fix. Rest of data may not decode correctly.");}
if ($qual == 1) {print STDOUT ("GPS fix.");}
if ($qual == 2) {print STDOUT ("Differential GPS fix.");}

print STDOUT ("   Satellites= $Parm[7]");

print STDOUT ("   Horiz Dilution= $Parm[8]\n");

&TIME_NMEA($Parm[1]);
&POSIT    ($Parm[2], $Parm[3], $Parm[4], $Parm[5]);

if (!&GPSxxx) {&SSIDSYM;}

$feet = sprintf("%10.1f", $Parm[9] * $mt2ft); $feet =~ s/ //g;
print STDOUT (" Ant height= $Parm[9] meters \($feet feet\)");

$feet = sprintf("%10.1f", $Parm[11] * $mt2ft); $feet =~ s/ //g;
print STDOUT ("  Geoidal height= $Parm[11] meters \($feet feet\)\n");

}


#---------------------------------------------------------------
# RMC.
# [0] = $GPRMC    [1] = HMS     [2] = Status  [3] = Lat
# [4] = N/S       [5] = Long    [6] = E/W     [7] = Speed
# [8] = Course    [9] = Date    [10]= Mag Var [11]= MV E/W *Csum
#---------------------------------------------------------------

sub RMC 
{
print STDOUT (" Status= ");

if ($Parm[2] eq "A") {print STDOUT ("Valid Position\n");}
if ($Parm[2] eq "V") {print STDOUT ("**WARNING: Invalid Position. Rest of data may not decode correctly.\n");}

&DATE     ($Parm[9]);
&TIME_NMEA($Parm[1]);
&POSIT    ($Parm[3], $Parm[4], $Parm[5], $Parm[6]);

if (!&GPSxxx) {&SSIDSYM;}

print STDOUT (" Course= $Parm[8] deg  ");

print STDOUT ("Ground");
&SPEEDK($Parm[7]);

$mv = substr($Parm[11], 0, 1);

print STDOUT (" Magnetic Variation= $Parm[10] deg $mv\n");
}


#---------------------------------------------------------------
# GLL.
# [0] = $GPGLL    [1] = Lat     [2] = N/S     [3] = Long
# [4] = E/W       [5] = HMS     [6] = Status *Csum
#---------------------------------------------------------------

sub GLL 
{
&TIME_NMEA($Parm[5]);
&POSIT    ($Parm[1], $Parm[2], $Parm[3], $Parm[4]);
if (!&GPSxxx) {&SSIDSYM;}
}


#---------------------------------------------------------------
# VTG.
# [0] = $GPVTG    [1] = True Cse[2] = T     [3] = Mag Cse
# [4] = M         [5] = Knots   [6] = N     [7] = kph
# [8] = K*csum    
#---------------------------------------------------------------

sub VTG 
{
if (!&GPSxxx) {&SSIDSYM;}

print STDOUT (" True Course= $Parm[1] deg  Magnetic Course= $Parm[3] \n");

print STDOUT (" Ground Speed= $Parm[5] knots\n");

print STDOUT (" Ground Speed= $Parm[7] kph\n");
}


1;
